function net = rnn_esn_new_ex

IUC = 0;
HUC = 1000;
OUC = 1;

% set number of all units
AUC = 1+IUC+HUC+OUC;

% set numbers of units
net.numInputUnits    = IUC;
net.numHiddenUnits   = HUC;
net.numOutputUnits   = OUC;
net.numAllUnits      = AUC;

% set neuron masks
net.maskInputUnits   = [0; ones(IUC, 1); zeros(AUC-1-IUC, 1)];
net.maskOutputUnits  = [zeros(AUC-OUC, 1); ones(OUC, 1)];
net.indexOutputUnits = find(net.maskOutputUnits);
net.indexInputUnits  = find(net.maskInputUnits);

% set input weights
weight = struct('dest',0,'source',0,'delay',0,'value',0);

backwardWeights = [-0.5 0.5];
nw = 1;

% for i=(AUC-1:-1:3),
for i=(2:AUC-1),
    % bias weight
    net.weights(nw).value  = 0.5;
    net.weights(nw).dest   = i;
    net.weights(nw).source = 1;
    net.weights(nw).delay  = 0;
    nw = nw+1;

    % backward weight
    net.weights(nw).value  = backwardWeights(mod(i,length(backwardWeights))+1);
    net.weights(nw).dest   = i;
    net.weights(nw).source = AUC;
    net.weights(nw).delay  = 1;
    nw = nw+1;
    
    if i>3,
        net.weights(nw).value  = -0.90;
        net.weights(nw).dest   = i;
        net.weights(nw).source = i-1;
        net.weights(nw).delay  = 1;
        nw = nw+1;
    end;
    if i>4,    
        net.weights(nw).value  = 0.90;
        net.weights(nw).dest   = i;
        net.weights(nw).source = floor(i/2);
        net.weights(nw).delay  = 1;
        nw = nw+1;
    end;
end;


% set number of weights
net.numWeights = nw-1;
net.firstForwardWeight = nw;
    
% initialize starting activities from [0, 1]

net.maxDelay = 51;

% initialize initial activations from [-1, 1]
net.actInit = 2.0 * rand(net.numAllUnits, net.maxDelay) - 1.0;

neto = net;



function weight = init_weight(prob, rng)

weight = 0;
if rand > prob, return; end;

weight = 2.0 * rand - 1.0;
if rng >= 0, 
    weight = weight .* rng;
else 
    if weight  < 0; weight =  rng;
    else weight = -rng; 
    end;
end; 



function node = rnd_node(nodes)

nodei = ceil(rand * length(nodes));
node = nodes(nodei);

